Index: src/UIElements/CommandLineUIFactory.cpp
===================================================================
--- src/UIElements/CommandLineUIFactory.cpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/UIElements/CommandLineUIFactory.cpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -28,5 +28,5 @@
 }
 
-MainWindow* CommandLineUIFactory::makeMainWindow(menuPopulaters populaters,MoleculeListClass *molecules, config *configuration, periodentafel *periode, char *ConfigFileName) {
-  return new CommandLineWindow(populaters,molecules,configuration,periode,ConfigFileName);
+MainWindow* CommandLineUIFactory::makeMainWindow(menuPopulaters populaters) {
+  return new CommandLineWindow(populaters);
 }
Index: src/UIElements/CommandLineUIFactory.hpp
===================================================================
--- src/UIElements/CommandLineUIFactory.hpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/UIElements/CommandLineUIFactory.hpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -19,5 +19,5 @@
 
   virtual Dialog* makeDialog();
-  virtual MainWindow* makeMainWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *);
+  virtual MainWindow* makeMainWindow(menuPopulaters);
 
 protected:
Index: src/UIElements/CommandLineWindow.cpp
===================================================================
--- src/UIElements/CommandLineWindow.cpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/UIElements/CommandLineWindow.cpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -16,5 +16,5 @@
 
 // TODO: see what code can be moved to a base class for Graphic and CommandLine Windows
-CommandLineWindow::CommandLineWindow(menuPopulaters populaters,MoleculeListClass *molecules, config *configuration, periodentafel *periode, char *ConfigFileName)
+CommandLineWindow::CommandLineWindow(menuPopulaters populaters)
 {
 
Index: src/UIElements/CommandLineWindow.hpp
===================================================================
--- src/UIElements/CommandLineWindow.hpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/UIElements/CommandLineWindow.hpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -16,5 +16,5 @@
 {
 public:
-  CommandLineWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *);
+  CommandLineWindow(menuPopulaters);
   virtual ~CommandLineWindow();
 
Index: src/UIElements/MainWindow.hpp
===================================================================
--- src/UIElements/MainWindow.hpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/UIElements/MainWindow.hpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -28,5 +28,5 @@
  * The type of menuPopulators
  */
-typedef void (*MenuMaker)(Menu*,MoleculeListClass*, config*, periodentafel*);
+typedef void (*MenuMaker)(Menu*);
 
 /**
Index: src/UIElements/TextUIFactory.cpp
===================================================================
--- src/UIElements/TextUIFactory.cpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/UIElements/TextUIFactory.cpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -27,6 +27,6 @@
 }
 
-MainWindow* TextUIFactory::makeMainWindow(menuPopulaters populaters,MoleculeListClass *molecules, config *configuration, periodentafel *periode, char *ConfigFileName) {
-  return new TextWindow(populaters,molecules,configuration,periode,ConfigFileName);
+MainWindow* TextUIFactory::makeMainWindow(menuPopulaters populaters) {
+  return new TextWindow(populaters);
 }
 
Index: src/UIElements/TextUIFactory.hpp
===================================================================
--- src/UIElements/TextUIFactory.hpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/UIElements/TextUIFactory.hpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -19,5 +19,5 @@
 
   virtual Dialog* makeDialog();
-  virtual MainWindow* makeMainWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *);
+  virtual MainWindow* makeMainWindow(menuPopulaters);
 
 protected:
Index: src/UIElements/TextWindow.cpp
===================================================================
--- src/UIElements/TextWindow.cpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/UIElements/TextWindow.cpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -27,4 +27,5 @@
 #include "molecule.hpp"
 #include "periodentafel.hpp"
+#include "World.hpp"
 
 #include "Legacy/oldmenu.hpp"
@@ -48,6 +49,10 @@
 
 // TODO: see what code can be moved to a base class for Graphic and Text Windows
-TextWindow::TextWindow(menuPopulaters populaters,MoleculeListClass *molecules, config *configuration, periodentafel *periode, char *ConfigFileName)
+TextWindow::TextWindow(menuPopulaters populaters)
 {
+  MoleculeListClass *molecules = World::getInstance().getMolecules();
+  config *configuration = NULL;
+  periodentafel *periode = World::getInstance().getPeriode();
+  char *ConfigFileName = NULL;
   old_menu = new oldmenu;
 
@@ -101,5 +106,5 @@
   // call all functions used to build the submenus
 
-  populaters.MakeEditMoleculesMenu(editMoleculesMenu,molecules,configuration,periode);
+  populaters.MakeEditMoleculesMenu(editMoleculesMenu);
 
   Action *returnFromEditMoleculeAction = new TextMenu::LeaveAction(editMoleculesMenu);
Index: src/UIElements/TextWindow.hpp
===================================================================
--- src/UIElements/TextWindow.hpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/UIElements/TextWindow.hpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -20,5 +20,5 @@
 {
 public:
-  TextWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *);
+  TextWindow(menuPopulaters);
   virtual ~TextWindow();
 
Index: src/UIElements/UIFactory.hpp
===================================================================
--- src/UIElements/UIFactory.hpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/UIElements/UIFactory.hpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -38,5 +38,5 @@
    * Produce some kind of main window, of whichever type was chosen when the factory was created
    */
-  virtual MainWindow* makeMainWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *)=0;
+  virtual MainWindow* makeMainWindow(menuPopulaters)=0;
 
   /**
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision ecb799f93fbb2fa0d7303a32021e627c4640f375)
+++ src/builder.cpp	(revision 4a75d9fe88b150cd8a65bf75e04c21f37e355b28)
@@ -2514,5 +2514,8 @@
 /***************************************** Functions used to build all menus **********************/
 
-void populateEditMoleculesMenu(Menu* editMoleculesMenu,MoleculeListClass *molecules, config *configuration, periodentafel *periode){
+void populateEditMoleculesMenu(Menu* editMoleculesMenu){
+  MoleculeListClass *molecules = World::getInstance().getMolecules();
+  periodentafel *periode = World::getInstance().getPeriode();
+
   // build the EditMoleculesMenu
   Action *createMoleculeAction = new MethodAction("createMoleculeAction",boost::bind(&MoleculeListClass::createNewMolecule,molecules,periode));
@@ -2587,5 +2590,5 @@
       populaters.MakeEditMoleculesMenu = populateEditMoleculesMenu;
 
-      MainWindow *mainWindow = UIFactory::getInstance().makeMainWindow(populaters,World::getInstance().getMolecules(), configuration, World::getInstance().getPeriode(), ConfigFileName);
+      MainWindow *mainWindow = UIFactory::getInstance().makeMainWindow(populaters);
       mainWindow->display();
       delete mainWindow;
